// rcrsn51 2015-08-17

#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>

static GtkStatusIcon *create_tray_icon();
void tray_icon_on_click(GtkStatusIcon *status_icon, gpointer user_data);

GtkStatusIcon *tray_icon;  // made global so tray_icon_on_click can see it

char *ICONFILE0="/usr/share/pixmaps/bluetooth-off.png";
char *ICONFILE1="/usr/share/pixmaps/bluetooth-on.png";

void turnon()
{
  system("bluetoothd");
  gtk_status_icon_set_from_file(tray_icon,ICONFILE1); 
  gtk_status_icon_set_tooltip(tray_icon,"Bluetooth: On");
}

void turnoff()
{
  system("killall bluetoothd");
  gtk_status_icon_set_from_file(tray_icon,ICONFILE0);
  gtk_status_icon_set_tooltip(tray_icon,"Bluetooth: Off");
} 

int main(int argc, char *argv[])
{
	sleep(5);
  gtk_init(&argc, &argv);
  tray_icon = create_tray_icon();
  gtk_main();
  return 0;
}

static GtkStatusIcon *create_tray_icon()
{
  tray_icon = gtk_status_icon_new();
  g_signal_connect(G_OBJECT(tray_icon), "activate",G_CALLBACK(tray_icon_on_click), NULL);
  turnon();
  system("modprobe btusb");
  gtk_status_icon_set_visible(tray_icon, TRUE);
  return tray_icon;
}

void tray_icon_on_click(GtkStatusIcon *status_icon, gpointer user_data)
{
  if (system("pidof bluetoothd") == 0)  // bluetooth daemon is running
    turnoff();
  else
    turnon(); 
}
